{by Alexey Monastyrenko}
{slightly changed by Valery Votintsev ( vv ) }
{$R-,Q-,S-,Q-}
uses Crt,SetPal;

type TScr = array[0..199,0..319] of Byte;
var Scr: TScr absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;

procedure VIDMode(Mode : Byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

procedure SqrPic(var Pic1:TScr; var Pal1:TPaletteLinear;
                 var Pic2:TScr; var Pal2:TPaletteLinear);
var TmpScr:^TScr;
var X,Y,I,J:Integer;
begin
  GetMem(TmpScr,320*200);
  PaletteLinear:=Pal1; SetPalette;
  for I:=199 downto 0 do begin
    for Y:=0 to I do Scr[Y] :=Pic1[Y];
    for Y:=I to 199 do Scr[Y] :=Pic1[I];
  end;

  for I:=0 to 32 do begin
    for X:=0 to 319 do begin
      TmpScr^[0,X]:=((32-I)*(Pic1[0,X])+I*Pic2[0,X]+16) div 32;
    end;
    for Y:=0 to 199 do Scr[Y]:=TmpScr^[0]; {}Delay(16);{}
    for J:=0 to 256*3-1 do begin
      PaletteLinear[J]:=(I*Pal2[J]+(32-I)*Pal1[J]+16) div 32;
    end;
    SetPalette;
  end;

  PaletteLinear:=Pal2; SetPalette;
  for I:=0 to 199 do begin
    for Y:=0 to I do Scr[Y] :=Pic2[Y];
    for Y:=I to 199 do Scr[Y] :=Pic2[I];
  end;
  FreeMem(TmpScr,320*200);
end;

var X,Y,X1,Y1:Integer;
    I,J:Longint;
    F:file;
    Scr3,Scr4: ^TScr;
    Pal3,Pal4:TPalette;
    Pal3L:TPaletteLinear absolute Pal3;
    PAL4L:TPaletteLinear absolute PAL4;
begin
  vidMode($13);                       { 320x200x256 graphics mode }
  GetMem(Scr3,320*200);

  GetMem(Scr4,320*200);
 repeat

  Assign(F,'monster.scr'); ReSet(F,1);
  BlockRead(F,Scr4^,320*200);
  Close(F);
  Assign(F,'monster.PAL'); ReSet(F,1);
  BlockRead(F,PAL4,SizeOf(TPaletteLinear));
  Close(F);

  Assign(F,'monhorse.scr'); ReSet(F,1);
  BlockRead(F,Scr3^,320*200);
  Close(F);
  Assign(F,'monhorse.PAL'); ReSet(F,1);
  BlockRead(F,Pal3,SizeOf(TPaletteLinear));
  Close(F);

  SqrPic(Scr3^,Pal3L,Scr4^,Pal4L); Delay(1000);
  SqrPic(Scr4^,Pal4L,Scr3^,Pal3L); Delay(1000);

 until KeyPressed;
  FreeMem(Scr4,320*200);
  FreeMem(Scr3,320*200);

{vv}  vidMode(3);  { Text mode }
end.