{by Alexey Monastyrenko}
{slightly changed by Valery Votintsev ( vv ) }
{$R-,Q-,S-,Q-}
uses Crt,SetPal;

type TScr = array[0..199,0..319] of Byte;
var Scr: TScr absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;
var Scr3,Scr4: ^TScr;
var ICos:array[0..255] of Byte;

const color:byte=255;

procedure VIDMode(Mode : Byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

procedure ChangePIC(var PIC2:TScr; var PAL2:TPaletteLinear; var CtrlPIC:TScr); {asm}
var J,K:Integer;
    I:Longint;
    PAL1:TPaletteLinear;
    label M1,M2,M3;
begin
  PAL1:=PaletteLinear;
  for J:=0 to 255 do begin
    if KeyPressed then goto M1;
    asm
    push ds
    push es
    mov si,word ptr[CtrlPic];
    add si,320*200-1
    mov ax,word ptr[CtrlPic+2]
    mov es,ax
    mov di,word ptr[Pic2]
    add di,320*200-1
    mov ax,word ptr[Pic2+2]
    mov ds,ax
    mov dx,$A000
{    for I:=0 to 320*200-1 do begin}
    mov cx,320*200-1
    mov bx,j
m3:

{      if TScr2(CtrlPIC)[I]=J
        then TScr2(Scr)[I]:=TScr2(PIC2)[I];}
    cmp bl,[es:si]
    jne m2
    push es
    push si
    mov es,dx
    mov si,cx
    mov al,byte ptr[ds:di]
    mov byte ptr[es:si],al
    pop si
    pop es
{    end;}
M2: dec di
    dec si
    loop m3
    pop es
    pop ds
end;
    for K:=0 to 256*3-1 do begin
      PaletteLinear[K]:=Hi(J*PAL2[K]+(256-J)*PAL1[K]);
    end;
    SetPalette;
  end;
M1:if KeyPressed then ReadKey;
end;

procedure LoadNewPIC(Name:string);
var TmpScr:^TScr;
    F:file;
    PAL2:TPaletteLinear;
begin
  GetMem(TmpScr,320*200);
  Assign(F,Name+'.scr'); ReSet(F,1);
  BlockRead(F,TmpScr^,320*200);
  Close(F);
  Assign(F,Name+'.PAL'); ReSet(F,1);
  BlockRead(F,PAL2,SizeOf(TPaletteLinear));
  Close(F);
  ChangePIC(TmpScr^,PAL2,Scr3^);
  FreeMem(TmpScr,320*200);
end;

procedure SqrPIC(var PIC2:TScr; Grow:Boolean);
const A:Integer=0;
var X,Y,I:Integer;
begin
  if Grow then A:=0
          else A:=511;
  for I:=1 to 10 do begin
    if Grow then A:=A shl 1 + 1
            else A:= A shr 1;
    for Y:=0 to 199 do
      for X:=0 to 319 do
        Scr[Y,X]:=PIC2[(Y+A shr 1)and not A, (X+A shr 1) and not A];
    Delay(100);
  end;
end;


function L(X:Integer):Byte;
begin
  if X<-256 then L:=L(X+512) else
  if X<0 then L:=-1-X else
  if X<256 then L:=X else
  L:=L(X-512);
end;

var X,Y,X1,Y1:Integer;
    I,J:Longint;
    F:file;
    PAL2,PAL3:TPalette;
    PAL2L:TPaletteLinear absolute PAL2;
    PAL3L:TPaletteLinear absolute PAL3;
begin
  vidMode($13);                       { 320x200x256 graphics mode }
  GetMem(Scr3,320*200);

  Randomize;
  for I:=0 to 255 do begin
    ICos[I]:=128-Round(127*Cos(I*2*PI/256));{}
  end;

  FillChar(PAL2,SizeOf(PAL2),#0);
  Palette:=PAL2; {SetPalette;}

(*  for Y:=0 to 199 do begin
    for X:=0 to 319 do begin
      I:=0;
      for J:=6 to 6 do begin
        Inc(I,{Round(Sqrt(Sqr(Int(X)-160)+Sqr(Y-100)))}
              (Abs(X-160) + Abs(Y-100)) +
              (ICos[Lo((X-160)*J)] shr 2+ICos[Lo((Y-100)*J)] shr 2 ));
      end;
      Scr3^[Y,X]:=L(I);{}
    end;
  end; *)

  Assign(F,'plasma.img'); ReSet(F,1);
  BlockRead(F,Scr3^,320*200);
  Close(F);
  GetMem(Scr4,320*200);
 repeat
  LoadNewPIC('monhorse'); Delay(1000);

  for I:=1 to 31 do begin
    asm
      cli
      MOV DX,3D4h                      { CRT controller }
      MOV AL,09h
      OUT DX,AL
      INC DX    { ⠥ maximum scan line }
      IN  AL,DX
      AND AL,0E0h                    { Duplicate each scan 8 times. }
      mov bl,byte ptr i
      ADD AL,bl {᫮ 㡫஢  scanline -1}
      OUT DX,AL
      sti
    end;
    Delay(150 div (I+1));
  end;
  for I:=31 downto 1 do begin
    asm
      cli
      MOV DX,3D4h                      { CRT controller }
      MOV AL,09h
      OUT DX,AL
      INC DX    { ⠥ maximum scan line }
      IN  AL,DX
      AND AL,0E0h                    { Duplicate each scan 8 times. }
      mov bl,byte ptr i
      ADD AL,bl {᫮ 㡫஢  scanline -1}
      OUT DX,AL
      sti
    end;
    Delay(150 div (I+1));
  end;

  LoadNewPIC('monster'); Delay(1000);

  Assign(F,'monster.scr'); ReSet(F,1);
  BlockRead(F,Scr4^,320*200);
  Close(F);
  SqrPIC(Scr4^,True);
  SqrPIC(Scr4^,False); Delay(1000);

{  FillChar(PAL2,SizeOf(PAL2),#0);}
{  FillChar(Scr4^,320*200,#0);
  ChangePIC(Scr4^,PAL3L,Scr3^);}
 until KeyPressed;
  FreeMem(Scr4,320*200);
  FreeMem(Scr3,320*200);


{vv}  vidMode(3);     { Text mode }
end.