{by Alexey Monastyrenko}
{slightly changed by Valery Votintsev ( vv ) }

{$R-,Q-,S-,Q-}
uses Crt,SetPAL;

type TScr = array[0..199,0..319] of Byte;
var Scr: TScr absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;

procedure VIDMode(Mode : Byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

procedure SqrPic(var Pic1:TScr; var Pal1:TPaletteLinear;
                 var Pic2:TScr; var Pal2:TPaletteLinear);
var TMPScr:^TScr;
var X,Y,I,J,A1,A2:Integer;
    R1,R2,RR:Word;
begin
  GetMem(TmpScr,320*200);
  for I:=0 to 41 do begin
    J:=I; if J>21 then J:=41-J;
    A1:=J shl 1 + 1; A2:= A1 shr 1;
    for Y:=0 to 199 do begin
      for X:=0 to 319 do begin
        RR:=(RR+MemW[$F800:X])*17+12345;
        R1:=RR mod A1;
        RR:=(RR+MemW[$F800:X])*17+12345;
        R2:=RR mod A1;
        if Random(11)+15<I
          then TMPScr^[Y,X]:=Pic2[Y+R2-A2, X+R1-A2]
          else TMPScr^[Y,X]:=Pic1[Y+R2-A2, X+R1-A2];
      end;
    end;
    Scr:=TMPScr^;
    for J:=0 to 256*3-1 do begin
      PaletteLinear[J]:=(I*Pal2[J]+(41-I)*Pal1[J]+20) div 41;
    end;
    SetPalette;
  end;
  FreeMem(TMPScr,320*200);
end;

var X,Y,X1,Y1:Integer;
    I,J:Longint;
    F:file;
    Scr3,Scr4: ^TScr;
    Pal3,Pal4:TPalette;
    Pal3L:TPaletteLinear absolute Pal3;
    PAL4L:TPaletteLinear absolute PAL4;
begin
  vidMode($13);                       { 320x200x256 graphics mode }
  GetMem(Scr3,320*200);

  GetMem(Scr4,320*200);
 repeat

  Assign(F,'monster.scr'); ReSet(F,1);
  BlockRead(F,Scr4^,320*200);
  Close(F);
  Assign(F,'monster.PAL'); ReSet(F,1);
  BlockRead(F,PAL4,SizeOf(TPaletteLinear));
  Close(F);

  Assign(F,'monhorse.scr'); ReSet(F,1);
  BlockRead(F,Scr3^,320*200);
  Close(F);
  Assign(F,'monhorse.PAL'); ReSet(F,1);
  BlockRead(F,Pal3,SizeOf(TPaletteLinear));
  Close(F);

  SqrPic(Scr3^,Pal3L,Scr4^,Pal4L); Delay(1000);
  SqrPic(Scr4^,Pal4L,Scr3^,Pal3L); Delay(1000);

 until KeyPressed;
  FreeMem(Scr4,320*200);
  FreeMem(Scr3,320*200);
{vv}   vidMode(3);           { Text mode }
end.