unit SetPAL;

interface

type TPalette=array[0..255,0..2] of Byte;
type TPaletteLinear=array[0..256*3-1] of Byte;
var Palette: TPalette;
    PaletteLinear: TPaletteLinear absolute Palette;

procedure PALSector(I     { 梥 RGB}
                   ,J1,J2 {࠭  (j2  砥)}
                   ,c1,c2 {梥  ࠭}
                          : byte);

procedure SetPalette;
procedure RotatePalette(BEG,FIn:Byte; N:ShortInt);

implementation

procedure PALSector(I     { 梥 RGB}
                   ,J1,J2 {࠭  (j2  砥)}
                   ,c1,c2 {梥  ࠭}
                          : byte);
var j:byte;
    jj:integer;
begin
  jj := j2-j1; if jj<=0 then inc(jj,256);
  J := J1;
  for J := 0 to JJ-1 do
    Palette[j1+j,i] := c1 + (integer(c2)-c1)*j div jj;
end;

procedure SetPalette;
var i:word;
begin
  Port[$3C8] := 0;
  for I := 0 to 256*3-1 do begin
    Port[$3C9] := PaletteLinear[I]
  end;
end; {of SetPalette}

procedure RotatePalette(beg,fin:byte; n:shortint);
var i,j:integer;
    TmpPal:TPalette;
begin
  TmpPal := Palette;
  for i:=beg to fin do begin
    j := i+n;
    if      j<beg then j:=j+fin-beg+1
    else if j>fin then j:=j-fin+beg-1;
    Palette[i] := TmpPal[j];
  end;
  Port[$3C8] := 0;
  for i := 0 to 256*3-1 do begin
    Port[$3C9] := PaletteLinear[i]
  end;
end; {of RotatePalette}

end.